'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _rcTweenOne = require('rc-tween-one');

var _rcTweenOne2 = _interopRequireDefault(_rcTweenOne);

var _rcQueueAnim = require('rc-queue-anim');

var _rcQueueAnim2 = _interopRequireDefault(_rcQueueAnim);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function toArrayChildren(children) {
    var ret = [];
    _react2.default.Children.forEach(children, function (c) {
        ret.push(c);
    });
    return ret;
}

function findChildInChildrenByKey(children, key) {
    var ret = null;
    if (children) {
        children.forEach(function (c) {
            if (ret || !c) {
                return;
            }
            if (c.key === key) {
                ret = c;
            }
        });
    }
    return ret;
}

function mergeChildren(prev, next) {
    var ret = [];
    prev.forEach(function (c) {
        if (!c) {
            return;
        }
        var newChild = findChildInChildrenByKey(next, c.key);
        if (newChild) {
            ret.push(newChild);
        }
    });

    next.forEach(function (c, i) {
        if (!c) {
            return;
        }
        var newChild = findChildInChildrenByKey(prev, c.key);
        if (!newChild) {
            ret.splice(i, 0, c);
        }
    });
    return ret;
}

var ListSort = (_temp = _class = function (_React$Component) {
    _inherits(ListSort, _React$Component);

    function ListSort(props) {
        _classCallCheck(this, ListSort);

        var _this = _possibleConstructorReturn(this, (ListSort.__proto__ || Object.getPrototypeOf(ListSort)).call(this, props));

        _this.onTouchStart = function (i, e) {
            if (_this.isDrage) {
                return;
            }
            if (e.target.id != _this.state.touchId) {
                return;
            }
            var rect = _this.dom.getBoundingClientRect();
            document.body.style.overflow = 'hidden';
            _this.props.onEventChange(e, 'down');
            var style = {
                height: rect.height + 'px',
                userSelect: 'none',
                WebkitUserSelect: 'none',
                MozUserSelect: 'none',
                MsUserSelect: 'none'
            };
            _this.children = Array.prototype.slice.call(_this.dom.children);
            _this.childStyle = [];
            var childStyle = _this.children.map(function (item, ii) {
                var cItem = _this.children[ii + 1];
                var marginHeight = void 0;
                var marginWidth = void 0;
                if (cItem) {
                    marginHeight = cItem.offsetTop - item.offsetTop - item.clientHeight;
                    marginWidth = cItem.offsetLeft - item.offsetLeft - item.clientWidth;
                } else {
                    var parentHeight = item.parentNode.clientHeight - parseFloat(getComputedStyle(item.parentNode).getPropertyValue('padding-bottom'));
                    var parentWidth = item.parentNode.clientWidth - parseFloat(getComputedStyle(item.parentNode).getPropertyValue('padding-right'));
                    marginHeight = parentHeight - item.offsetTop - item.clientHeight;
                    marginWidth = parentWidth - item.offsetLeft - item.clientWidth;
                }
                var d = {
                    width: item.clientWidth,
                    height: item.clientHeight,
                    top: item.offsetTop,
                    left: item.offsetLeft,
                    margin: 'auto',
                    marginHeight: marginHeight,
                    marginWidth: marginWidth,
                    position: 'absolute',
                    zIndex: ii === i ? 1 : 0
                };
                _this.childStyle.push(_extends({}, d));
                return d;
            });
            var animation = _this.children.map(function (item, ii) {
                return i === ii && (!_this.props.dragClassName ? { scale: 1.2, boxShadow: '0 10px 10px rgba(0,0,0,0.15)' } : null) || null;
            });
            _this.index = i;
            _this.swapIndex = i;
            _this.mouseXY = {
                startX: e.touches === undefined ? e.clientX : e.touches[0].clientX,
                startY: e.touches === undefined ? e.clientY : e.touches[0].clientY,
                top: childStyle[i].top,
                left: childStyle[i].left
            };
            if (_this.props.dragClassName) {
                _this.listDom = e.currentTarget;
            }
            _this.timeOutEvent = setTimeout(function () {
                _this.timeOutEvent = 0;
                _this.props.onTouch();
                if (_this.props.dragClassName) {
                    _this.listDom.className = _this.listDom.className.replace(_this.props.dragClassName, '').trim() + ' ' + _this.props.dragClassName;
                }
                _this.isDrage = true;
                _this.setState({
                    style: style,
                    childStyle: childStyle,
                    animation: animation,
                    move: true
                });
            }, 400);
        };

        _this.onTouchMove = function (e) {
            if (!_this.mouseXY) {
                return;
            }
            if (_this.state.move) {
                _this.mouseXY.x = e.touches === undefined ? e.clientX : e.touches[0].clientX;
                _this.mouseXY.y = e.touches === undefined ? e.clientY : e.touches[0].clientY;
                var childStyle = _this.state.childStyle;
                var animation = _this.state.animation;
                if (_this.props.animType === 'y') {
                    childStyle[_this.index].top = _this.mouseXY.y - _this.mouseXY.startY + _this.mouseXY.top;
                    _this.swapIndex = childStyle[_this.index].top < _this.childStyle[_this.index].top ? 0 : _this.index;
                    _this.swapIndex = childStyle[_this.index].top > _this.childStyle[_this.index].top + _this.childStyle[_this.index].height ? childStyle.length - 1 : _this.swapIndex;

                    var top = childStyle[_this.index].top;
                    _this.childStyle.forEach(function (item, i) {
                        var cTop = item.top;
                        var cHeight = item.height + item.marginHeight;
                        if (top > cTop && top < cTop + cHeight) {
                            _this.swapIndex = i;
                        }
                    });
                    animation = animation.map(function (item, i) {
                        // 到顶端
                        var height = _this.childStyle[_this.index].height;
                        if (_this.index < _this.swapIndex) {
                            if (i > _this.index && i <= _this.swapIndex && _this.swapIndex !== _this.index) {
                                var start = _this.index + 1;
                                var end = i;
                                height = 0;
                                _this.childStyle.slice(start, end).forEach(function (_item) {
                                    height += _item.height + _item.marginHeight;
                                });
                                return { top: _this.childStyle[_this.index].top + height };
                            } else if ((i > _this.swapIndex || _this.swapIndex === _this.index) && i !== _this.index) {
                                return { top: _this.childStyle[i].top };
                            }
                        } else if (_this.index > _this.swapIndex) {
                            if (i < _this.index && i >= _this.swapIndex && _this.swapIndex !== _this.index) {
                                height = _this.childStyle[_this.index].height + _this.childStyle[_this.index].marginHeight;
                                return { top: _this.childStyle[i].top + height };
                            } else if ((i < _this.swapIndex || _this.swapIndex === _this.index) && i !== _this.index) {
                                return { top: _this.childStyle[i].top };
                            }
                        }
                        if (i !== _this.index) {
                            return { top: _this.childStyle[i].top };
                        }
                        return item;
                    });
                }
                _this.setState({ childStyle: childStyle, animation: animation });
            }
        };

        _this.onTouchEnd = function (e) {
            if (!_this.mouseXY) {
                return;
            }
            if (_this.props.longTap) {
                clearTimeout(_this.timeOutEvent);
                _this.timeOutEvent = 0;
            }
            if (_this.state.move) {
                _this.mouseXY = null;
                document.body.style.overflow = null;
                _this.props.onEventChange(e, 'up');
                var animation = _this.state.animation.map(function (item, i) {
                    if (_this.index === i) {
                        var animate = {};
                        var height = 0;
                        if (_this.props.animType === 'y') {
                            if (_this.swapIndex > _this.index) {
                                var start = _this.index + 1;
                                var end = _this.swapIndex + 1;
                                _this.childStyle.slice(start, end).forEach(function (_item) {
                                    height += _item.height + _item.marginHeight;
                                });
                                animate.top = height + _this.childStyle[_this.index].top;
                            } else {
                                animate.top = _this.childStyle[_this.swapIndex].top;
                            }
                        }
                        var dragScale = !_this.props.dragClassName && {
                            scale: 1,
                            boxShadow: '0 0px 0px rgba(0,0,0,0)'
                        };
                        return _extends({}, dragScale, animate, {
                            onComplete: function onComplete() {
                                var children = _this.sortArray(_this.state.children, _this.swapIndex, _this.index);
                                var callbackBool = _this.index !== _this.swapIndex;
                                _this.index = null;
                                _this.childStyle = [];
                                _this.swapIndex = null;
                                _this.setState({
                                    style: {},
                                    childStyle: [],
                                    children: children,
                                    animation: [],
                                    move: false
                                }, function () {
                                    _this.isDrage = false;
                                    if (callbackBool) {
                                        _this.props.onChange(children);
                                    } else {
                                        _this.props.onChange();
                                    }
                                });
                            }
                        });
                    }
                    return item;
                });
                if (_this.props.dragClassName) {
                    _this.listDom.className = '' + _this.listDom.className.replace(_this.props.dragClassName, '').trim();
                }
                _this.setState({ animation: animation });
            }
        };

        _this.getChildren = function (item, i) {
            var onTouchStart = _this.onTouchStart.bind(_this, i);
            var style = _extends({}, _this.state.childStyle[i]);
            return _react2.default.createElement(_rcTweenOne2.default, _extends({}, item.props, {
                onTouchStart: onTouchStart,
                style: _extends({}, item.style, style),
                key: item.key,
                animation: _this.state.animation[i],
                component: item.type
            }));
        };

        _this.sortArray = function (_array, nextNum, num) {
            var current = _array[num];
            var array = _array.map(function (item) {
                return item;
            });
            array.splice(num, 1);
            array.splice(nextNum, 0, current);
            return array;
        };

        _this.state = {
            children: _this.props.children,
            touchId: _this.props.touchId,
            style: {},
            childStyle: [],
            animation: [],
            move: false
        };
        _this.index = null;
        _this.swapIndex = null;
        _this.mouseXY = null;
        _this.childStyle = [];
        _this.children = [];
        _this.isDrage = false;
        _this.timeOutEvent = 0;
        return _this;
    }

    _createClass(ListSort, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.dom = _reactDom2.default.findDOMNode(this);

            if (window.addEventListener) {
                window.addEventListener('touchmove', this.onTouchMove);
                window.addEventListener('touchend', this.onTouchEnd);
            } else {
                window.attachEvent('ontouchmove', this.onTouchMove);
                window.attachEvent('ontouchend', this.onTouchEnd);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            var currentChildren = this.state.children;
            var nextChildren = nextProps.children;
            var newChildren = mergeChildren(currentChildren, nextChildren);
            this.setState({ children: newChildren });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (window.addEventListener) {
                window.removeEventListener('touchmove', this.onTouchMove);
                window.removeEventListener('touchend', this.onTouchEnd);
            } else {
                window.detachEvent('ontouchmove', this.onTouchMove);
                window.detachEvent('ontouchend', this.onTouchEnd);
            }
            clearTimeout(this.timeOutEvent);
            this.timeOutEvent = 0;
        }
    }, {
        key: 'render',
        value: function render() {
            var childrenToRender = toArrayChildren(this.state.children).map(this.getChildren);
            var props = _extends({}, this.props);
            ['component', 'animType', 'touchId', 'dragClassName', 'appearAnim', 'onEventChange', 'onTouch', 'longTap'].forEach(function (key) {
                return delete props[key];
            });
            if (this.props.appearAnim) {
                return _react2.default.createElement(_rcQueueAnim2.default, _extends({}, props, this.props.appearAnim, {
                    style: _extends({}, this.state.style)
                }), childrenToRender);
            }
            return _react2.default.createElement(this.props.component, _extends({}, props, {
                style: _extends({}, this.state.style)
            }), childrenToRender);
        }
    }]);

    return ListSort;
}(_react2.default.Component), _class.propTypes = {
    component: _propTypes2.default.any,
    children: _propTypes2.default.any,
    animType: _propTypes2.default.string,
    onChange: _propTypes2.default.any,
    dragClassName: _propTypes2.default.string,
    appearAnim: _propTypes2.default.object,
    onEventChange: _propTypes2.default.any,
    onTouch: _propTypes2.default.any,
    touchId: _propTypes2.default.string,
    longTap: _propTypes2.default.bool
}, _class.defaultProps = {
    component: 'div',
    animType: 'y',
    touchId: "id",
    longTap: true,
    onTouch: function onTouch() {},
    onChange: function onChange() {},
    onEventChange: function onEventChange() {}
}, _temp);
exports.default = ListSort;