'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _swiper = require('./../swiper');

var _swiper2 = _interopRequireDefault(_swiper);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Zoom = function (_Component) {
  _inherits(Zoom, _Component);

  function Zoom(props) {
    _classCallCheck(this, Zoom);

    var _this2 = _possibleConstructorReturn(this, (Zoom.__proto__ || Object.getPrototypeOf(Zoom)).call(this, props));

    _this2.state = {
      hasLoaded: false,
      isZoomed: true,
      src: props.image.src,
      index: 0
    };
    _this2.unzoom = _this2.unzoom.bind(_this2);
    _this2.touchmove = _this2.touchMove.bind(_this2);
    return _this2;
  }

  _createClass(Zoom, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      setTimeout(function () {
        _this3.setState({ hasLoaded: true });
        _this3.container.addEventListener('touchmove', _this3.touchmove, false);
      }, _utils.transitionDuration);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.container.removeEventListener('touchmove', this.touchmove, false);
    }
  }, {
    key: 'touchMove',
    value: function touchMove(e) {
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _state = this.state,
          isZoomed = _state.isZoomed,
          index = _state.index,
          _props = this.props,
          image = _props.image,
          items = _props.items,
          activeIndex = _props.activeIndex;

      var style = this._getZoomImageStyle();
      var _this = this;
      var params = {
        initialSlide: activeIndex,
        on: {
          slideChange: function slideChange(e) {
            _this.setState({
              index: this.activeIndex
            });
          }
        }
      };
      var imgStyle = {
        maxWidth: '100%',
        maxHeight: '100%',
        position: 'absolute',
        top: '50%',
        left: '50%',
        transform: 'translate(-50%, -50%)'
      };
      return _react2.default.createElement(
        'div',
        null,
        image ? _react2.default.createElement(
          'div',
          {
            ref: function ref(container) {
              return _this4.container = container;
            },
            className: 'zoomContainer',
            style: {
              position: 'fixed',
              top: 0,
              right: 0,
              bottom: 0,
              left: 0,
              zIndex: -1,
              overflowY: 'hidden'
            }
          },
          _react2.default.createElement(_Overlay2.default, { isVisible: isZoomed }),
          _react2.default.createElement(
            'div',
            { style: style },
            _react2.default.createElement(
              _swiper2.default,
              params,
              items.map(function (val, index) {
                return _react2.default.createElement(
                  'div',
                  { key: index, style: { width: '100%', height: '100%', background: 'none' } },
                  _react2.default.createElement('img', { alt: '', src: val.image, style: imgStyle })
                );
              })
            )
          ),
          _react2.default.createElement(
            'div',
            { style: this._getPagination() },
            _react2.default.createElement(
              'font',
              { style: { fontSize: 18 } },
              index + 1
            ),
            '/',
            items.length
          )
        ) : null
      );
    }
  }, {
    key: 'unzoom',
    value: function unzoom() {
      var onUnzoom = this.props.onUnzoom(this.state.src, this.state.index);
      this.setState({ isZoomed: false }, function () {
        setTimeout(onUnzoom, _utils.transitionDuration);
      });
    }
  }, {
    key: '_getZoomImageStyle',
    value: function _getZoomImageStyle() {
      var image = this.props.image;

      var imageOffset = image.getBoundingClientRect();
      var top = imageOffset.top,
          left = imageOffset.left;
      var width = image.width,
          height = image.height;


      var style = { top: top, left: left, width: width, height: height };

      var viewportX = document.body.clientWidth / 2;
      var viewportY = window.innerHeight / 2;

      var imageCenterX = imageOffset.left + width / 2;
      var imageCenterY = imageOffset.top + height / 2;

      var translateX = viewportX - imageCenterX;
      var translateY = viewportY - imageCenterY;

      var zoomStyle = {
        transform: 'translate3d(' + translateX + 'px, ' + translateY + 'px, 0) scale(1)'
      };

      if (!this.state.hasLoaded || !this.state.isZoomed) {
        return Object.assign({
          cursor: 'zoom-out',
          position: 'absolute',
          transition: 'transform ' + _utils.transitionDuration + 'ms',
          transform: 'translate3d(0, 0, 0) scale(1)',
          transformOrigin: 'center center',
          willChange: 'transform, top, left',
          top: style.top,
          left: 0,
          right: 0,
          width: '100%',
          margin: '0 auto',
          height: style.height
        }, this.props.style);
      }
      this.container.style.zIndex = 999;
      return Object.assign({
        cursor: 'zoom-out',
        position: 'absolute',
        transition: 'transform ' + _utils.transitionDuration + 'ms',
        transform: 'translate3d(0, 0, 0) scale(1)',
        transformOrigin: 'center center',
        willChange: 'transform, top, left',
        top: style.top,
        left: 0,
        width: '100%',
        height: style.height
      }, this.props.style, zoomStyle);
    }
  }, {
    key: '_getPagination',
    value: function _getPagination() {
      var style = {
        width: '100%',
        position: 'absolute',
        top: 15,
        left: 0,
        opacity: 0,
        transition: 'opacity ' + _utils.transitionDuration + 'ms',
        zIndex: 1,
        textAlign: 'center'
      };
      if (!this.state.hasLoaded || !this.state.isZoomed) {
        return style;
      }
      return Object.assign(style, {
        opacity: 1
      });
    }
  }]);

  return Zoom;
}(_react.Component);

exports.default = Zoom;


Zoom.propTypes = {
  index: _propTypes2.default.number,
  activeIndex: _propTypes2.default.number,
  image: _propTypes2.default.object.isRequired,
  onSlideChange: _propTypes2.default.func,
  onUnzoom: _propTypes2.default.func.isRequired
};