'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _swiper = require('./swiper');

var _swiper2 = _interopRequireDefault(_swiper);

var _video = require('../video');

require('./index.less');

var _EventsWrapper = require('./Zoom/EventsWrapper');

var _EventsWrapper2 = _interopRequireDefault(_EventsWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var fromscroll = 0;
var toscroll = 0;
var timer = null;

var swiper = function (_Component) {
    _inherits(swiper, _Component);

    function swiper(props) {
        _classCallCheck(this, swiper);

        var _this2 = _possibleConstructorReturn(this, (swiper.__proto__ || Object.getPrototypeOf(swiper)).call(this, props));

        _this2.state = {
            scrollTop: 0,
            swiping: "swiper-container-horizontal swiper-container-ios",
            image: false,
            activeIndex: 0,
            isZoomed: false,
            play: false
        };

        _this2._handleZoom = function () {
            if (!_this2.state.image.getAttribute("error")) {
                _this2.setState({
                    isZoomed: true
                });
            }
        };

        _this2.videoplay = function (e, index) {
            var play = {
                play: {}
            };
            play['play']['player_' + index] = true;
            _this2.setState(play, function () {
                _this2['player_' + index].play();
                _this2.swipers.swiper.$wrapperEl[0].style.zIndex = 11;
            });
        };

        _this2.videoFullscreen = function (e) {
            // let windowHeight = window.innerHeight;
            // if(!e.isFullscreen){
            //   this.swiper.swiper.$el[0].setAttribute('style', `width: ${this.swiper.swiper.size}px;height: ${windowHeight}px`);
            // } else {
            //   this.swiper.swiper.$el[0].setAttribute('style', `width: ${this.swiper.swiper.size}px;height: ${this.swiper.swiper.size}px`);
            // }
        };

        _this2.onExitVideo = function (index) {
            var play = {
                play: {}
            };
            play['play']['player_' + index] = false;
            _this2.setState(play, function () {
                _this2.swipers.swiper.$wrapperEl[0].style.zIndex = 1;
            });
        };

        _this2.onUnzoom = function (e, activeIndex) {
            _this2.setState({ activeIndex: activeIndex });
            _this2.swipers.swiper.slideTo(activeIndex, 0);
            setTimeout(function () {
                _this2.setState({ isZoomed: false });
            }, 300);
        };

        _this2.enableTouchControl = function (index) {
            var node = _this2['image_' + index].offsetParent;
            var obj_class = (' ' + node.className + ' ').replace(/(\s+)/gi, ' ');
            var removed = obj_class.replace('swiper-no-swiping', ' ').replace(/(^\s+)|(\s+$)/g, '');
            node.className = removed;
        };

        _this2.disableTouchControl = function (index) {
            var node = _this2['image_' + index].offsetParent;
            var obj_classs = node.className;
            var obj_class_lst = obj_classs.split(/\s+/);
            var x = 0;
            var hasClass = false;
            for (x in obj_class_lst) {
                if (obj_class_lst[x] === 'swiper-no-swiping') {
                    hasClass = true;
                }
            }
            if (!hasClass) {
                var obj_class = node.className,
                    blank = obj_class !== '' ? ' ' : '';
                var added = obj_class + blank + "swiper-no-swiping";
                node.className = added;
            }
        };

        _this2.lock = false;
        return _this2;
    }

    _createClass(swiper, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('scroll', this.handleScroll.bind(this));
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.lock = true;
            window.removeEventListener('scroll', this.handleScroll.bind(this));
        }
    }, {
        key: 'handleScroll',
        value: function handleScroll(e) {
            clearTimeout(timer);
            var scrollTop = e ? e.srcElement.documentElement.scrollTop || window.pageYOffset || e.srcElement.body.scrollTop : 0;
            timer = setTimeout(function () {
                toscroll = e ? e.srcElement.documentElement.scrollTop || window.pageYOffset || e.srcElement.body.scrollTop : 0;
                if (toscroll === fromscroll) {
                    if (!this.lock) {
                        this.setState({
                            swiping: "swiper-container-horizontal swiper-container-ios"
                        });
                    }
                }
            }.bind(this), 100);
            fromscroll = scrollTop;
            if (!this.lock) {
                this.setState({
                    scrollTop: scrollTop,
                    swiping: "swiper-no-swiping swiper-container-horizontal swiper-container-ios"
                });
            }
            this.updateParallax();
        }
    }, {
        key: 'updateParallax',
        value: function updateParallax() {
            var scrollTop = this.state.scrollTop;

            if (!this.lock) {
                var containerHeight = this.el.offsetHeight;
                if (this.el) {
                    var children = this.el.children[0];
                    var parallaxDist = 800 - containerHeight;
                    var top = children.offsetTop;
                    var windowHeight = window.innerHeight;
                    var windowBottom = scrollTop + windowHeight;
                    var windowTop = windowBottom - windowHeight;
                    var percentScrolled = (windowTop - top) / (containerHeight + windowHeight);
                    var parallax = parallaxDist * (percentScrolled > 0 ? percentScrolled : 0) / 1.1415926;
                    if (scrollTop < 0) {
                        parallax = parallaxDist * (percentScrolled > 0 ? percentScrolled : 0) + windowTop / 2;
                    }
                    children.style.transform = "translate(0, " + parallax + "px) translateZ(0)";
                }
            }
        }
    }, {
        key: 'handleImageErrored',
        value: function handleImageErrored(e) {
            var errorImage = this.props.errorImage;

            e.target.src = errorImage;
            e.target.setAttribute("error", true);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var _props = this.props,
                className = _props.className,
                item = _props.item;
            var _state = this.state,
                swiping = _state.swiping,
                image = _state.image,
                isZoomed = _state.isZoomed,
                activeIndex = _state.activeIndex,
                play = _state.play;

            var clsString = (0, _classnames2.default)("parallax_container", className);
            var _this = this;
            var attrs = {
                className: 'banner-swiper-lazy image',
                onClick: this._handleZoom
            };
            var option = {
                lazy: {
                    loadPrevNext: true,
                    loadOnTransitionStart: true,
                    elementClass: 'banner-swiper-lazy',
                    loadedClass: 'banner-swiper-lazy-loaded',
                    preloaderClass: 'banner-swiper-lazy-preloader'
                },
                preloadImages: false,
                containerClass: swiping,
                initialSlide: activeIndex,
                isparallax: true,
                observer: true,
                oninit: function oninit() {
                    _this.setState({
                        activeIndex: this.activeIndex,
                        image: _this['image_' + this.activeIndex]
                    });
                },
                slideChange: function slideChange() {
                    var _this3 = this;

                    _this.setState({
                        activeIndex: this.activeIndex,
                        image: _this['image_' + this.activeIndex]
                    });
                    if (_this.state.play && _this.state.play['player_' + this.activeIndex]) {
                        _this['player_' + this.activeIndex].play();
                        this.$wrapperEl[0].style.zIndex = 11;
                    } else {
                        _this.state.play && Object.keys(_this.state.play).forEach(function (item, index) {
                            _this[item] && _this[item].pause();
                            _this3.$wrapperEl[0].style.zIndex = 1;
                        });
                    }
                },
                pagination: {
                    el: '.swiper-pagination',
                    type: 'fraction',
                    renderFraction: function renderFraction(currentClass, totalClass) {
                        return '<div class="pagination"><font class="' + currentClass + '"></font>/<font class="' + totalClass + '"></font></div>';
                    }
                }
            };
            if (this.swipers) {
                setTimeout(function () {
                    if (_this4.swipers) {
                        _this4.swipers.swiper.lazy.load();
                    }
                }, 100);
            }
            return _react2.default.createElement(
                'div',
                { className: clsString, ref: function ref(banner) {
                        return _this4.el = banner;
                    } },
                _react2.default.createElement(
                    _swiper2.default,
                    _extends({}, option, { ref: function ref(swipers) {
                            return _this4.swipers = swipers;
                        } }),
                    item.map(function (item, index) {
                        return _react2.default.createElement(
                            'div',
                            { key: index },
                            play['player_' + index] ? _react2.default.createElement(_video.Player, {
                                autoPlay: true,
                                ref: function ref(x) {
                                    _this4['player_' + index] = x;
                                },
                                playsInline: true,
                                poster: item.image,
                                src: item.url,
                                exitVideo: function exitVideo() {
                                    return _this4.onExitVideo(index);
                                },
                                disableTouchControl: function disableTouchControl() {
                                    return _this4.disableTouchControl(index);
                                },
                                enableTouchControl: function enableTouchControl() {
                                    return _this4.enableTouchControl(index);
                                },
                                toggleFullscreen: function toggleFullscreen(e) {
                                    return _this4.videoFullscreen(e);
                                }
                            }) : null,
                            _react2.default.createElement('img', _extends({}, attrs, { alt: 'img', ref: function ref(x) {
                                    _this4['image_' + index] = x;
                                }, 'data-src': item.image, onError: function onError(e) {
                                    return _this4.handleImageErrored(e);
                                } })),
                            _react2.default.createElement('div', { className: 'banner-swiper-lazy-preloader' }),
                            item.type === "video" ? _react2.default.createElement('span', { className: 'video-button', onClick: function onClick() {
                                    return _this4.videoplay(_this4, index);
                                } }) : null
                        );
                    })
                ),
                image && isZoomed ? _react2.default.createElement(_EventsWrapper2.default, { key: 'portal', items: item, index: option.initialSlide, activeIndex: activeIndex, image: image, onUnzoom: this.onUnzoom }) : null
            );
        }
    }]);

    return swiper;
}(_react.Component);

swiper.defaultProps = {
    className: ""
};
swiper.propTypes = {
    className: _propTypes2.default.string
};
exports.default = swiper;